package cn.iocoder.yudao.module.pms.service.iotrddailyreportdetail;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotrddailyreportdetail.vo.IotRdDailyReportDetailPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotrddailyreportdetail.vo.IotRdDailyReportDetailSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotrddailyreportdetail.IotRdDailyReportDetailDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotrddailyreportdetail.IotRdDailyReportDetailMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_RD_DAILY_REPORT_DETAIL_NOT_EXISTS;


/**
 * 瑞都日报明细(生产动态拆分) Service 实现类
 *
 * @author ruiqi
 */
@Service
@Validated
public class IotRdDailyReportDetailServiceImpl implements IotRdDailyReportDetailService {

    @Resource
    private IotRdDailyReportDetailMapper iotRdDailyReportDetailMapper;

    @Override
    public Long createIotRdDailyReportDetail(IotRdDailyReportDetailSaveReqVO createReqVO) {
        // 插入
        IotRdDailyReportDetailDO iotRdDailyReportDetail = BeanUtils.toBean(createReqVO, IotRdDailyReportDetailDO.class);
        iotRdDailyReportDetailMapper.insert(iotRdDailyReportDetail);
        // 返回
        return iotRdDailyReportDetail.getId();
    }

    @Override
    public void updateIotRdDailyReportDetail(IotRdDailyReportDetailSaveReqVO updateReqVO) {
        // 校验存在
        validateIotRdDailyReportDetailExists(updateReqVO.getId());
        // 更新
        IotRdDailyReportDetailDO updateObj = BeanUtils.toBean(updateReqVO, IotRdDailyReportDetailDO.class);
        iotRdDailyReportDetailMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotRdDailyReportDetail(Long id) {
        // 校验存在
        validateIotRdDailyReportDetailExists(id);
        // 删除
        iotRdDailyReportDetailMapper.deleteById(id);
    }

    private void validateIotRdDailyReportDetailExists(Long id) {
        if (iotRdDailyReportDetailMapper.selectById(id) == null) {
            throw exception(IOT_RD_DAILY_REPORT_DETAIL_NOT_EXISTS);
        }
    }

    @Override
    public IotRdDailyReportDetailDO getIotRdDailyReportDetail(Long id) {
        return iotRdDailyReportDetailMapper.selectById(id);
    }

    @Override
    public PageResult<IotRdDailyReportDetailDO> getIotRdDailyReportDetailPage(IotRdDailyReportDetailPageReqVO pageReqVO) {
        return iotRdDailyReportDetailMapper.selectPage(pageReqVO);
    }

}